#include <Servo.h>

#include <WallVis.h>

WallVis node(
  "new001",     // Our ID
  "WallVisNet", //Wifi Access Point
  "wallvisAP",  //WiFi Password
  "192.168.4.1",//IP address of Node RED server
  1883          //Port for Node RED server
  );


// Set up the servo we will use
Servo s1 = Servo();

void setup()
{
  // Attach the servo to the right pin on the board
  s1.attach(D3);

  //Get the serial port ready
  Serial.begin(115200);

  //Add in a test behaviour that responds to the command 'hello'
  node.add(new TestBehaviour("hello") );

  //Add in three different versions of the servo wiggling, with different speed parameters
  node.add(new ServoWiggle(s1, "wiggle") );
  node.add(new ServoWiggle(s1, "slow_wiggle", 10) );
  node.add(new ServoWiggle(s1, "fast_wiggle", 1) );
  
  //Add in a behaviour that just goes to a certain angle, with the default name 'goto'
  node.add(new ServoGoto(s1) );

  //Initialise the whole infrastructure
  node.init();
}


void loop()
{
  //Should be all we have to do
  node.vis_loop();
}
